package nova.monadic_sfx.util.controls

import com.jfoenix.{controls => jfoenixc}
import scalafx.Includes._
import scalafx.beans.property.BooleanProperty
import scalafx.scene.control.TextArea
import scalafx.scene.paint.Paint

object JFXTextArea {
  implicit def sfxTextArea2jfx(v: JFXTextArea): jfoenixc.JFXTextArea =
    if (v != null) v.delegate else null
}
// extends TextInputControl(delegate)
//     with SFXDelegate[jfoenixc.JFXTextArea]
class JFXTextArea(
    override val delegate: jfoenixc.JFXTextArea = new jfoenixc.JFXTextArea()
) extends TextArea(delegate) {

  /**
    * Creates a TextArea with initial text content.
    *
    * @param text - A string for text content.
    */
  def this(text: String) = this(new jfoenixc.JFXTextArea(text))

  def labelFloat = delegate.labelFloatProperty()
  def labelFloat_=(v: Boolean) = delegate.setLabelFloat(v)

  def focusColor: Paint = delegate.getFocusColor()
  def focusColor_=(color: Paint) = delegate.setFocusColor(color)

  def unFocusColor = delegate.getUnFocusColor()
  def unFocusColor_=(color: Paint) = delegate.setUnFocusColor(color)

  def disableAnimation: BooleanProperty = delegate.disableAnimationProperty()

  def disableAnimation_=(disable: Boolean) =
    delegate.setDisableAnimation(disable)

}
